using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_Users
    /// </summary>
    public partial class T_Sys_Users
    {
        public T_Sys_Users()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string usercode)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Users");
            strSql.Append(" where F_OpenId=@F_OpenId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OpenId", SqlDbType.VarChar,100)
            };
            parameters[0].Value = usercode;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public long Add(CallCenterApi.Model.T_Sys_Users model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Users(");
            strSql.Append("F_OpenId,F_CreateTime,F_Type,F_Password,F_Name,F_Telphone,F_Sex,F_Province,F_City,F_County,F_Address,F_ImgUrl)");
            strSql.Append(" values (");
            strSql.Append("@F_OpenId,@F_CreateTime,@F_Type,@F_Password,@F_Name,@F_Telphone,@F_Sex,@F_Province,@F_City,@F_County,@F_Address,@F_ImgUrl)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OpenId", SqlDbType.VarChar,100),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Password", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Telphone", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sex", SqlDbType.Int,4),
                    new SqlParameter("@F_Province", SqlDbType.VarChar,50),
                    new SqlParameter("@F_City", SqlDbType.VarChar,50),
                    new SqlParameter("@F_County", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Address", SqlDbType.VarChar,500),
                    new SqlParameter("@F_ImgUrl", SqlDbType.VarChar,500)};
            parameters[0].Value = model.F_OpenId;
            parameters[1].Value = model.F_CreateTime;
            parameters[2].Value = model.F_Type;
            parameters[3].Value = model.F_Password;
            parameters[4].Value = model.F_Name;
            parameters[5].Value = model.F_Telphone;
            parameters[6].Value = model.F_Sex;
            parameters[7].Value = model.F_Province;
            parameters[8].Value = model.F_City;
            parameters[9].Value = model.F_County;
            parameters[10].Value = model.F_Address;
            parameters[11].Value = model.F_ImgUrl;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt64(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Users model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Users set ");
            strSql.Append("F_OpenId=@F_OpenId,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Password=@F_Password,");
            strSql.Append("F_Name=@F_Name,");
            strSql.Append("F_Telphone=@F_Telphone,");
            strSql.Append("F_Sex=@F_Sex,");
            strSql.Append("F_Province=@F_Province,");
            strSql.Append("F_City=@F_City,");
            strSql.Append("F_County=@F_County,");
            strSql.Append("F_Address=@F_Address,");
            strSql.Append("F_ImgUrl=@F_ImgUrl");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OpenId", SqlDbType.VarChar,100),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Password", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Telphone", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sex", SqlDbType.Int,4),
                    new SqlParameter("@F_Province", SqlDbType.VarChar,50),
                    new SqlParameter("@F_City", SqlDbType.VarChar,50),
                    new SqlParameter("@F_County", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Address", SqlDbType.VarChar,500),
                    new SqlParameter("@F_ImgUrl", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Id", SqlDbType.BigInt,8)};
            parameters[0].Value = model.F_OpenId;
            parameters[1].Value = model.F_CreateTime;
            parameters[2].Value = model.F_Type;
            parameters[3].Value = model.F_Password;
            parameters[4].Value = model.F_Name;
            parameters[5].Value = model.F_Telphone;
            parameters[6].Value = model.F_Sex;
            parameters[7].Value = model.F_Province;
            parameters[8].Value = model.F_City;
            parameters[9].Value = model.F_County;
            parameters[10].Value = model.F_Address;
            parameters[11].Value = model.F_ImgUrl;
            parameters[12].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(long F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Users ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.BigInt)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Users ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Users GetModel(string usercode)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_OpenId,F_CreateTime,F_Type,F_Password,F_Name,F_Telphone,F_Sex,F_Province,F_City,F_County,F_Address,F_ImgUrl from T_Sys_Users ");
            strSql.Append(" where F_OpenId=@F_OpenId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OpenId", SqlDbType.VarChar,100)
            };
            parameters[0].Value = usercode;

            CallCenterApi.Model.T_Sys_Users model = new CallCenterApi.Model.T_Sys_Users();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Users GetModel(long F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_OpenId,F_CreateTime,F_Type,F_Password,F_Name,F_Telphone,F_Sex,F_Province,F_City,F_County,F_Address,F_ImgUrl from T_Sys_Users ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.BigInt)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Sys_Users model = new CallCenterApi.Model.T_Sys_Users();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Users DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Users model = new CallCenterApi.Model.T_Sys_Users();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = long.Parse(row["F_Id"].ToString());
                }
                if (row["F_OpenId"] != null)
                {
                    model.F_OpenId = row["F_OpenId"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Password"] != null)
                {
                    model.F_Password = row["F_Password"].ToString();
                }
                if (row["F_Name"] != null)
                {
                    model.F_Name = row["F_Name"].ToString();
                }
                if (row["F_Telphone"] != null)
                {
                    model.F_Telphone = row["F_Telphone"].ToString();
                }
                if (row["F_Sex"] != null && row["F_Sex"].ToString() != "")
                {
                    model.F_Sex = int.Parse(row["F_Sex"].ToString());
                }
                if (row["F_Province"] != null)
                {
                    model.F_Province = row["F_Province"].ToString();
                }
                if (row["F_City"] != null)
                {
                    model.F_City = row["F_City"].ToString();
                }
                if (row["F_County"] != null)
                {
                    model.F_County = row["F_County"].ToString();
                }
                if (row["F_Address"] != null)
                {
                    model.F_Address = row["F_Address"].ToString();
                }
                if (row["F_ImgUrl"] != null)
                {
                    model.F_ImgUrl = row["F_ImgUrl"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_OpenId,F_CreateTime,F_Type,F_Password,F_Name,F_Telphone,F_Sex,F_Province,F_City,F_County,F_Address,F_ImgUrl ");
            strSql.Append(" FROM T_Sys_Users ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_OpenId,F_CreateTime,F_Type,F_Password,F_Name,F_Telphone,F_Sex,F_Province,F_City,F_County,F_Address,F_ImgUrl ");
            strSql.Append(" FROM T_Sys_Users ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Users ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Users T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Users";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

